/*
File: Users.java
Date		Author		Changes
Aug 25 96	Lukasz Beca	Created
Oct 07 96       Lukasz Beca     Reading from file added
Tested:
OK

*/
package webwisdom.tango.structures;


import java.lang.*;
import java.util.*;
import java.io.*;

public class Users {

  private Vector UIDVector;
  private Vector NameVector;
  private Vector PasswdVector;
  private Vector PrivVector;

  // distribution
  private int currentUID;

  public Users() {
    UIDVector = new Vector();
    NameVector = new Vector();
    PasswdVector = new Vector();
    PrivVector = new Vector();
    currentUID = 1;
    
  }

  public synchronized void addUser(String name, String passwd, String privpar) {

    int UID = newUID();
    Integer a = new Integer(UID);
    UIDVector.addElement(a);
    NameVector.addElement(name);
    PasswdVector.addElement(passwd);
    PrivVector.addElement(privpar);
    System.out.println("Users: new user added; UID " + UID + " name " + name + " passwd " + passwd + " privileges " + privpar);
             
  }

  public synchronized void removeUser(int UID) {

    int index;
    String result;
    Integer tmp = new Integer(UID);
    index = UIDVector.indexOf(tmp);
   
    if (index == -1) {
      System.out.println("Users: user " + UID + " does not have an account, cannot remove");
    }
    else {

      UIDVector.removeElementAt(index);
      NameVector.removeElementAt(index);
      PasswdVector.removeElementAt(index);
      PrivVector.removeElementAt(index);
      System.out.println("Users: user " + UID + " removed");
    }
    
  }
   


  public synchronized String getPasswd(String name) {

    int index;
    String result;

    index = NameVector.indexOf(name);
    
    if (index == -1) { 
      System.out.println("Users: user " + name + " does not have an account, cannot find password");
      result = null;
    }
    else
      result = (String) PasswdVector.elementAt(index); 

    return result;

  }

  public synchronized String getName(int UID) {

    int index;
    String result;
    Integer tmp = new Integer(UID);

    index = UIDVector.indexOf(tmp);
    
    if (index == -1) {
      System.out.println("Users: user " + UID + " does not have an account, cannot find name");
      result = null;
    }
    else
      result = (String) NameVector.elementAt(index); 

    return result;

  }

   public synchronized String getPriv(int UID) {

    int index;
    String result;
    Integer tmp = new Integer(UID);

    index = UIDVector.indexOf(tmp);
     
    if (index == -1) {
      System.out.println("Users: user " + UID + " does not have an account, cannot find privileges");
      result = null;
    }
    else
      result = (String) PrivVector.elementAt(index); 

    return result;

  }



  public synchronized int getUID(String name) {
 
    //gets UID of name, if name does not exist in Users then 0 is returned   
  
    int index;
    int result;
    Integer tmp;

    index = NameVector.indexOf(name);
    if (index == -1) {
       System.out.println("Users: user " + name + " does not have an account, cannot find UID");
      result = -1;
    }
    else {
      tmp = (Integer) UIDVector.elementAt(index);
      result = tmp.intValue();
    }

    return result;
    
  }


  public synchronized int checkPasswd(String name, String passwd) { //checks whether password is ok
  //returns UID if password is valid, otherwise 0
    
    String p;
    int result;

    p = getPasswd(name);
    if (p != null)
      if (p.equals(passwd) ) 
	result = getUID(name);
      else
	result = 0;
    else
      result = 0;

    return result;

  }

  private int newUID() {

    int tmp;

    tmp = currentUID;
    currentUID ++;
    
    return tmp;

  }

}












